/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: fdopen.c,v 1.2 1993/08/16 13:35:37 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/xstdio.h>
#include <string.h>

/* Functions */
FILE *fdopen (int fd, const char *mode)
{
    int new_md;
    int old_md;
    FILE *fp;
    const char *p;
    char c;

#ifdef EBADF_CHECKER
    /* Lȃt@Cnh */
    if (_usedfd (fd) < 0) {
       errno = EBADF;
       return 0;
   }
#endif

    /* 󂢂Ă iob T */
    if ((fp = _getemptyiob ()) == 0) {
	errno = EMFILE;
	return 0;
    }

    /* ̃[h擾 */
    old_md = fcntl (fd, F_GETFL);

    /* mode  "b" "t" T */
    p = mode;
    while ((c = *p++) != '\0') {
	if ((c == 'b') || (c == 't'))
	    break;
    }

    if (c)
	/* "b" "t" ̎w肠 */
	p = mode;
    else {
	/* "b" "t" ̎wȂ */
	p = alloca (strlen (mode) + 1 + 1);
	strcpy ((char *)p, mode);
	/* ̃[hɉ "b" ܂ "t" A */
	if (old_md & O_BINARY)
	    strcat ((char *)p, "b");
	else
	    strcat ((char *)p, "t");
    }

    /* fp FILE \̂쐬 */
    if ((new_md = _sopen (fp, p, _IOFBF)) < 0) {
	fclose (fp);
	return 0;
    }

    /* I[v[h */
    new_md = (old_md & ~O_STSMODE) | (new_md & O_STSMODE);

    /* t@C[hĐݒ */
    fcntl (fd, F_SETFL, new_md);

    /* t@CfBXNv^ݒ肷 */
    fp->_file = fd;

    return fp;
}
